using ICSSoft.Common;
using ICSSoft.Entity;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICSSoft.DataProject
{
    /// <summary>
    /// 委外采购红字入库单
    /// </summary>
    public class OutsourcingReceiveDocNegative
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string connString = System.Configuration.ConfigurationManager.AppSettings["ERPConnStr"];
        private static string ERPDB = System.Configuration.ConfigurationManager.AppSettings["ERPDB"];
        private static string Type = System.Configuration.ConfigurationManager.AppSettings["Type"];
        private static string CRNALL = System.Configuration.ConfigurationManager.AppSettings["OutIssRCRDNAME"];
        /// <summary>
        /// 获取委外采购红字入库单
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public string Get(List<ICSOutsourcingReceiveDocNegative> infos)
        {

            List<ICSOutsourcingReceiveDocNegative> szJson = new List<ICSOutsourcingReceiveDocNegative>();
            DataTable dt = null;
            DataTable dtNew = null;
            string connS = "";
            string json = "";
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            string sql = string.Empty;

              List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


              foreach (string WorkPoint in result)
              {
                  try
                  {
                      connS = string.Format(connString, WorkPoint);
                      conn = new System.Data.SqlClient.SqlConnection(connS);
                      conn.Open();
                      SqlTransaction sqlTran = conn.BeginTransaction();
                      cmd = new SqlCommand();
                      cmd.Transaction = sqlTran;
                      cmd.Connection = conn;
                      foreach (ICSOutsourcingReceiveDocNegative info in infos)
                      {
                          if (WorkPoint != info.WorkPoint)
                              continue;


                          ICSUserInfo userInfo = new ICSUserInfo();
                          userInfo = DBHelper.GetPersonInfo(info.User, cmd);
                          if (info.MTime < new DateTime(2000, 01, 01))
                              throw new Exception("请输入正确的操作时间：" + info.MTime);
                          sql = @" select a.ID,iMPoIds,iordercode,a.cCode,a.cDepCode,c.cDepName,a.cWhCode,
                            d.cWhName,a.cSource,a.cMaker,dnmaketime,cHandler,dnverifytime,cSourceCodeLs,
                            b.AutoID ,b.irowno,b.cInvCode,b.iQuantity,e.MoDetailsID,b.iNum,e.csocode
                            from rdrecord01 a
                            left join rdrecords01 b on a.ID=b.ID
                            left join Department c on a.cDepCode=c.cDepCode
                            left join Warehouse d on a.cWhCode=d.cWhCode
                            left join OM_MODetails e on b.iOMoDID=e.MoDetailsID
                           where a.cBusType='委外加工'and b.iQuantity<0";
                          if (!string.IsNullOrWhiteSpace(info.ORCVNEGCode))
                          {
                              sql += " and a.cCode='{0}'";
                          }
                          if (!string.IsNullOrWhiteSpace(info.MTime.ToString()))
                          {
                              sql += " and ISNULL(a.dnmodifytime,ISNULL(a.dnverifytime, ISNULL(a.dnmodifytime, a.dnmaketime)))>='{1}'";
                          }
                          if (!string.IsNullOrWhiteSpace(info.User))
                          {
                              sql += "and a.CMAKER='{2}'";
                          }
                          sql = string.Format(sql, info.ORCVNEGCode, info.MTime, userInfo.UserName);
                          dt = DBHelper.SQlReturnData(sql, cmd);

                          if (dt.Rows.Count <= 0 || dt == null)
                              throw new Exception("委外采购红字入库单：" + info.ORCVNEGCode + "，无信息！");
                          if (dtNew == null)
                              dtNew = dt;
                          else
                              dtNew.Merge(dt);


                      }
                      cmd.Transaction.Commit();
                  }
                  catch (Exception ex)
                  {
                      cmd.Transaction.Rollback();
                      log.Error(ex.Message);
                      throw new Exception(ex.Message);
                  }
                  finally
                  {
                      if (conn.State == ConnectionState.Open)
                      {
                          conn.Close();
                      }
                      conn.Dispose();
                  }
              }
            json = JsonConvert.SerializeObject(dtNew);
            return json;

        }
        /// <summary>
        /// 创建委外采购入(到货单)
        /// </summary>
        /// <param name="Bills"></param>
        /// <returns></returns>
        public string CreateOutsourcingReceiveDocNegative(List<ICSOutsourcingReceiveDocNegative> Bills)
        {
            string msg = "";
            int num = 0;
            string sql = "";
            
            
            DataSet ds = null;
            string connS = "";
            int iFatherId = 0;
            int iChildId = 0;
            string iFatherIdTwo = "";
            //取得采购入库单单据 表头ID，表体DID
            VouchKey key = new VouchKey();
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            if (Bills.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            LogInfo(Bills);


             List<string> result = Bills.Select(t => t.WorkPoint).Distinct().ToList();


             foreach (string WorkPoint in result)
             {
                 try
                 {
                     connS = string.Format(connString, WorkPoint);
                     conn = new System.Data.SqlClient.SqlConnection(connS);
                     conn.Open();
                     SqlTransaction sqlTran = conn.BeginTransaction();
                     cmd = new SqlCommand();
                     cmd.Transaction = sqlTran;
                     cmd.Connection = conn;
                     foreach (ICSOutsourcingReceiveDocNegative head in Bills)
                     {
                         iFatherIdTwo = "";
                         num = head.details.Count();
                         if (WorkPoint != head.WorkPoint)
                             continue;
                         string[] ss = head.WorkPoint.Split('_');
                         ERPDB = ss[1];
                         if (!DBHelper.IsInventoryConsolidation(cmd, head.WorkPoint))
                             throw new Exception("U8正在整理现存量，请稍后再试");

                         //取得out库单的默认显示模版

                         ICSUserInfo userInfo = new ICSUserInfo();
                         userInfo = DBHelper.GetPersonInfo(head.User, cmd);

                         string[] dd = CRNALL.Split('~');
                         string crdname = dd[0];
                         string carname = dd[1];
                         string surface = dd[2];
                         string cardnewcode = DBHelper.GetCardNumber(carname, cmd);
                         Dictionary<string, int> dic = DBHelper.GetAllCode("" + ERPDB + "", surface, "" + num + "", head.WorkPoint);
                         iFatherId = Convert.ToInt32(dic["iFatherId"].ToString());
                         iChildId = Convert.ToInt32(dic["iChildId"].ToString());
                         DateTime date = DateTime.Now;
                         string cRDcode = DBHelper.GetRDCode(crdname, cmd);
                         string iBaseCodeLen = DBHelper.GetAllRDCode(cardnewcode, "" + date + "", "admin", cRDcode, head.WorkPoint);

                         string DEF_ID = DBHelper.GetDefaultTemplate(cardnewcode, cmd);
                         #region 验证数量不能大于到货单数量

                         foreach (ICSOutsourcingReceiveDocNegatives body in head.details)
                         {
                             sql = "SELECT isnull(-iQuantity,0) FROM dbo.PU_ArrivalVouchs WHERE Autoid='" + body.ODNRTDetailID + "'";
                             DataTable dtQty = DBHelper.SQlReturnData(sql, cmd);
                             if (dtQty != null && dtQty.Rows.Count > 0)
                             {
                                 //到货单可入数量
                                 decimal PUQty = Convert.ToDecimal(dtQty.Rows[0][0]);
                                 sql = "SELECT ISNULL(SUM(-iQuantity),0) FROM dbo.RdRecords01 WHERE iArrsId='" + body.ODNRTDetailID + "'";
                                 DataTable dtReceQty = DBHelper.SQlReturnData(sql, cmd);
                                 decimal ReceQty = Convert.ToDecimal(dtReceQty.Rows[0][0]);
                                 if (ReceQty + body.Quantity > PUQty)
                                 {
                                     throw new Exception("入库数量大于当前到货单行可入库数量！");
                                 }
                             }
                             else
                             {
                                 throw new Exception("U8不存在该到货单行！");
                             }
                         }

                         #endregion


                         string cfcode = string.Empty;
                         string zq = string.Empty;
                         string lz = string.Empty;
                         string dz = string.Empty;

                         sql = @"select  a.cCode,a.iLZYJ,a.iLZFS,iPLNum,dblZQNum,c.dDate,
                        (case when ilzfs=1 then dateadd(day,-day(getdate()),dateadd(month,1,getdate())) else DATEADD(day,isnull(iPLNum,0),c.dDate) end)
                         lz,DATEADD(day,isnull(dblZQNum,0),DATEADD(day,isnull(iPLNum,0),c.dDate)) dz 
                        from 
                        (select b.cVenPUOMProtocol,a.cvencode,a.dDate,a.cCode from PU_ArrivalVouch a
                        left join Vendor b on a.cvencode=b.cvencode
                        where  a.cCode='" + head.ODNRTCode + @"'
                        ) c 
                        left join AA_Agreement a on a.cCode=c.cVenPUOMProtocol
                        ";
                         DataTable dtDisCheck1 = DBHelper.SQlReturnData(sql, cmd);
                         if (dtDisCheck1 != null && dtDisCheck1.Rows.Count > 0)
                         {
                             foreach (DataRow item in dtDisCheck1.Rows)
                             {
                                 if (item["iLZYJ"].ToString() == "10" & (item["iLZFS"].ToString() == "0" | item["iLZFS"].ToString() == "1"))
                                 {
                                     cfcode = item["cCode"].ToString();
                                     zq = item["dblZQNum"].ToString();
                                     lz = item["lz"].ToString();
                                     dz = item["dz"].ToString();
                                 }
                                 else
                                 {
                                     if (item["cCode"].ToString() == "")
                                         cfcode = item["cCode"].ToString();
                                 }
                             }
                         }


                         #region 委外采购入库单 表头

                         sql = @"INSERT INTO dbo.RdRecord01
                        ( ID ,bRdFlag ,cVouchType ,cBusType ,cSource ,cWhCode ,
                          dDate ,cCode ,cRdCode ,cDepCode ,cPersonCode ,cPTCode ,
                          cVenCode ,cOrderCode ,cARVCode ,cHandler ,cMemo ,
                          bTransFlag ,cMaker ,cDefine1 ,cDefine2 ,cDefine3 ,
                          cDefine4 ,cDefine5 ,cDefine6 ,cDefine7 ,cDefine8 ,
                          cDefine9 ,cDefine10 ,dVeriDate ,bpufirst ,biafirst ,
                		  dARVDate ,VT_ID ,bIsSTQc ,cDefine11 ,cDefine12 ,
                          cDefine13 ,cDefine14 ,cDefine15 ,cDefine16 ,
                          ipurarriveid ,iTaxRate ,iExchRate ,cExch_Name ,bOMFirst,
                          bFromPreYear ,bIsComplement ,iDiscountTaxType ,
                          ireturncount ,iverifystate ,iswfcontrolled ,
                          cModifyPerson ,dnmaketime ,dnverifytime ,
                          bredvouch  ,bCredit ,iPrintCount,cVenPUOMProtocol,iCreditPeriod,dCreditStart,dGatheringDate)
                SELECT @ID,1,'01','委外加工','委外到货单',@cWhCode,
                		CONVERT(NVARCHAR(15),GETDATE(),23),@cCode,@cRdCode,@cDepCode,a.cPersonCode,'01',
                		a.cVenCode,b.cCode,a.cCode,@cHandler,a.cMemo,
                		0,@cMaker,a.cDefine1,a.cDefine2,a.cDefine3,
                		a.cDefine4,a.cDefine5,a.cDefine6,a.cDefine7,a.cDefine8,
                		a.cDefine9,a.cDefine10,CONVERT(NVARCHAR(15),GETDATE(),23),0,0,
                		a.dDate,@VT_ID,0,a.cDefine11,a.cDefine12,
                		a.cDefine13,a.cDefine14,a.cDefine15,a.cDefine16,
                		a.ID,a.iTaxRate,a.iExchRate,a.cexch_name,0,
                		0,0,0,
                		0,0,0,
                		'',GETDATE(),GETDATE(),
                		0,0,0,@cVenPUOMProtocol,@iCreditPeriod,@dCreditStart,@dGatheringDate
                 FROM dbo.PU_ArrivalVouch a LEFT JOIN dbo.OM_MOMain b ON a.cpocode=b.cCode WHERE a.cCode='" + head.ODNRTCode + "'";
                         cmd.Parameters.Clear();
                         cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
                         cmd.Parameters.Add(new SqlParameter("@cWhCode", head.WHCode));
                         cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
                         cmd.Parameters.Add(new SqlParameter("@cDepCode", ""));
                         cmd.Parameters.Add(new SqlParameter("@cHandler", userInfo.UserName));
                         cmd.Parameters.Add(new SqlParameter("@cMaker", userInfo.UserName));
                         cmd.Parameters.Add(new SqlParameter("@VT_ID", DEF_ID));
                         cmd.Parameters.Add(new SqlParameter("@cRdCode", cRDcode));
                         cmd.Parameters.Add(new SqlParameter("@cVenPUOMProtocol", cfcode));
                         cmd.Parameters.Add(new SqlParameter("@iCreditPeriod", zq));
                         cmd.Parameters.Add(new SqlParameter("@dCreditStart", lz));
                         cmd.Parameters.Add(new SqlParameter("@dGatheringDate", dz));
                         cmd.CommandText = sql;
                         try
                         {
                             int count = cmd.ExecuteNonQuery();
                             if (count <= 0)
                             {
                                 log.Error("委外采购入库单表头失败，受影响行数<=0；");
                                 throw new Exception("委外采购入库单表头失败，受影响行数<=0；");
                             }
                         }
                         catch (Exception ex)
                         {
                             log.Error("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
                             throw new Exception("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
                         }


                         #endregion

                         #region 采购入库单 表体
                         foreach (ICSOutsourcingReceiveDocNegatives body in head.details)
                         {
                             body.Quantity = -body.Quantity;
                             if (DBHelper.bInvBatch(body.InvCode, cmd) == true)
                             {
                                 if (body.BatchCode == "")
                                 {
                                     log.Error("该物料：" + body.InvCode + "已启用批次，请重新填写！");
                                     throw new Exception("该物料：" + body.InvCode + "已启用批次，请重新填写！");
                                 }
                             }
                             else
                             {
                                 if (body.BatchCode != "")
                                 {
                                     log.Error("该物料：" + body.InvCode + "未启用批次，请重新填写！");
                                     throw new Exception("该物料：" + body.InvCode + "未启用批次，请重新填写！");
                                 }
                             }
                             sql = @"INSERT INTO dbo.rdrecords01
          ( AutoID ,ID ,cInvCode ,iQuantity ,iUnitCost ,iPrice ,iAPrice ,iNum,
            iFlag ,iSQuantity ,iSNum ,iMoney ,
            cDefine22 ,cDefine23 ,cDefine24 ,cDefine25 ,cDefine26 ,cDefine27 ,
            cItem_class ,cItemCode ,iPOsID ,fACost ,cName  ,iNQuantity ,
            chVencode ,iArrsId ,iOriTaxCost ,iOriCost ,iOriMoney ,iOriTaxPrice ,
            ioriSum ,iTaxRate ,iTaxPrice ,iSum ,bTaxCost ,cPOID ,iMatSettleState ,
            iBillSettleCount ,bLPUseFree ,iOriTrackID ,bCosting ,cbarvcode ,
            dbarvdate ,iExpiratDateCalcu ,iordertype ,isotype ,irowno ,bgift,cBatch,iProcessFee, iProcessCost ,cFree1,cFree2,cFree3,cFree4,cFree5,cFree6,cFree7,cFree8,cFree9,cFree10)
  SELECT @AutoID,@ID1,@cInvCode,@iQuantity,0,0,0,@iNum,
  		0,0,0,0,
  		a.cDefine22,a.cDefine23,a.cDefine24,a.cDefine25,a.cDefine26,a.cDefine27,
  		a.cItem_class,@cItemCode,a.iPOsID,0,a.cItemName,a.iQuantity,
  		c.cVenCode,a.Autoid,0,0,0,0,
  		0,a.iTaxRate,0,0,1,d.cCode,0,
  		0,0,0,1,c.cCode,
  		c.dDate,0,0,0,@irowno,0,@cBatch,a.iCost*convert(decimal, @iQuantity),a.iCost,@cFree1,@cFree2,@cFree3,@cFree4,@cFree5,@cFree6,@cFree7,@cFree8,@cFree9,@cFree10
  FROM dbo.PU_ArrivalVouchs a LEFT JOIN dbo.OM_MODetails b ON a.iPOsID=b.MODetailsID
  INNER JOIN dbo.OM_MOMain d ON b.MOID=d.MOID
  INNER JOIN dbo.PU_ArrivalVouch c ON a.ID=c.ID where a.Autoid='" + body.ODNRTDetailID + @"'
EXEC PROC_Update_OM_RdRecord01 @ID= @ID1

";
                             cmd.Parameters.Clear();
                             cmd.Parameters.Add(new SqlParameter("@AutoID", iChildId));
                             cmd.Parameters.Add(new SqlParameter("@ID1", iFatherId));
                             cmd.Parameters.Add(new SqlParameter("@cInvCode", body.InvCode));
                             cmd.Parameters.Add(new SqlParameter("@iQuantity", -body.Quantity));
                             cmd.Parameters.Add(new SqlParameter("@iNum", -Convert.ToDecimal(body.Amount.ToString("0.00"))));
                             cmd.Parameters.Add(new SqlParameter("@irowno", body.Sequence));
                             cmd.Parameters.Add(new SqlParameter("@cBatch", body.BatchCode));
                             cmd.Parameters.Add(new SqlParameter("@cItemCode", body.ProjectCode));
                             cmd.Parameters.Add(new SqlParameter("@cFree1", body.cFree1));
                             cmd.Parameters.Add(new SqlParameter("@cFree2", body.cFree2));
                             cmd.Parameters.Add(new SqlParameter("@cFree3", body.cFree3));
                             cmd.Parameters.Add(new SqlParameter("@cFree4", body.cFree4));
                             cmd.Parameters.Add(new SqlParameter("@cFree5", body.cFree5));
                             cmd.Parameters.Add(new SqlParameter("@cFree6", body.cFree6));
                             cmd.Parameters.Add(new SqlParameter("@cFree7", body.cFree7));
                             cmd.Parameters.Add(new SqlParameter("@cFree8", body.cFree8));
                             cmd.Parameters.Add(new SqlParameter("@cFree9", body.cFree9));
                             cmd.Parameters.Add(new SqlParameter("@cFree10", body.cFree10));
                             cmd.CommandText = sql;
                             try
                             {
                                 int count = cmd.ExecuteNonQuery();
                                 if (count <= 0)
                                 {
                                     log.Error("委外采购入库单表头失败，受影响行数<=0；");
                                     throw new Exception("委外采购入库单表头失败，受影响行数<=0；");
                                 }
                             }
                             catch (Exception ex)
                             {
                                 log.Error("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
                                 throw new Exception("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
                             }

                             //OM_MODetails
                             sql = @"UPDATE b SET freceivedqty=ISNULL(freceivedqty,0)+" + -body.Quantity + @" 
                                FROM dbo.PU_ArrivalVouchs a LEFT JOIN dbo.OM_MODetails b ON a.iPOsID=b.MODetailsID
                                WHERE a.Autoid='" + body.ODNRTDetailID + "'";
                             DBHelper.CmdExecuteNonQuery(sql, cmd, "回写OM_MODetails失败！");
                             //回写PU_ArrivalVouchs失败
                             sql = "UPDATE dbo.PU_ArrivalVouchs SET fValidInQuan=ISNULL(fValidInQuan,0)+" + -body.Quantity + " WHERE Autoid='" + body.ODNRTDetailID + "'";
                             DBHelper.CmdExecuteNonQuery(sql, cmd, "回写PU_ArrivalVouchs失败！");

                      


                             sql = @"select isnull(fValidInQuan,0)fOutQuantity,isnull(iQuantity,0)iQuantity,ISNULL(iNum, 0)iNum,ISNULL(NiNum, 0)NiNum,ISNULL(iNum, 0)-ISNULL(NiNum, 0) SiNum from PU_ArrivalVouchs a
                        LEFT JOIN (select sum(iNum) NiNum,iArrsId from rdrecords01 GROUP BY iArrsId) b on a.Autoid=b.iArrsId
                        where  a.AutoID='" + body.ODNRTDetailID + "'";
                             DataTable dtDisCheck = DBHelper.SQlReturnData(sql, cmd);
                             if (dtDisCheck != null && dtDisCheck.Rows.Count > 0)
                             {
                                 foreach (DataRow item in dtDisCheck.Rows)
                                 {
                                     if (Convert.ToDecimal(item["fOutQuantity"].ToString()) == Convert.ToDecimal(item["iQuantity"].ToString()))
                                     {
                                         if (Convert.ToDecimal(item["iNum"].ToString()) != 0)
                                         {
                                             if (Convert.ToDecimal(item["SiNum"].ToString()) != 0)
                                             {
                                                 sql = @"Update rdrecords09 set iNum=isnull(iNum,0)+(" + item["SiNum"].ToString() + ") where autoid='" + iChildId + "' ";
                                                 body.Amount = (Convert.ToDecimal(body.Amount.ToString("0.00"))) + (Convert.ToDecimal(item["SiNum"].ToString()));
                                                 DBHelper.CmdExecuteNonQuery(sql, cmd, "辅计量余数处理失败！");
                                             }
                                         }
                                     }
                                 }

                             }

                             ////更新待入库数量
                             //sql = "UPDATE dbo.CurrentStock SET fInQuantity=ISNULL(fInQuantity,0)-" + -body.Quantity + " WHERE cInvCode='" + body.InvCode + "' AND cWhCode ='" + head.WHCode + "'";
                             //if (DBHelper.bInvBatch(body.InvCode, cmd) == true)
                             //{
                             //    if (!string.IsNullOrWhiteSpace(body.BatchCode))
                             //    {
                             //        sql += " and cBatch='" + body.BatchCode + "'";
                             //    }


                             //}
                             //else
                             //{
                             //    sql += " and cBatch=''";
                             //}

                             //DBHelper.CmdExecuteNonQuery(sql, cmd, "更新待入库数量失败！");

                             //更新现存量
                             key.cBustypeUN = "委外加工";
                             key.cVouchTypeUN = "01";
                             key.TableName = "IA_ST_UnAccountVouch01";
                             //DBHelper.UpdateCurrentStock(cmd, body.InvCode, head.WHCode, "", -body.Quantity, key);
                             //DBHelper.UpdateCurrentStockNEW(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, body.cFree1, body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10, key);

                             DBHelper.UpdateCurrentStockCCGC(cmd, body.InvCode, head.WHCode, body.BatchCode, -body.Quantity, -body.Amount, body.cFree1,
                                           body.cFree2, body.cFree3, body.cFree4, body.cFree5, body.cFree6, body.cFree7, body.cFree8, body.cFree9, body.cFree10,
                                           "", key, "", "", "", "", 0, 0, -body.Quantity, -body.Amount, 0, 0, 0, 0, iFatherId, iChildId);


                             iFatherIdTwo = "'" + iFatherId + "',";
                             iChildId--;
                         }

                         #endregion

                         #region 查询

                         sql = @"  select DISTINCT a.ID as ID,a.ID as IDs,a.cCode  as ORCVNEGCode ,a.cVenCode,d.cVenName,a.cOrderCode as OOCode, 
                       a.cMaker as CreateUser,dnmaketime as CreateDateTime,cHandler as Checker,dnverifytime as CheckDateTime
                           from rdrecord01 a
                       left join Department c on a.cDepCode=c.cDepCode
                       left join Vendor d on a.cVenCode=d.cVenCode
                          where a.cBusType='委外加工' AND A.ID in ({0}) 

                          select DISTINCT a.ID as IDs,b.AutoID as DetailID,b.iArrsId as ODNRTDetailID, b.irowno as Sequence,b.cInvCode as InvCode,b.iQuantity as Quantity,iNum as Amount,b.iOMoDID as OODetailID
,isnull(b.cItemCode,'') ProjectCode,isnull(b.cbatch,'') cBatch,'' version ,'' brand,
isnull(b.cFree1,'') as cFree1,
isnull(b.cFree2,'') as cFree2,
isnull(b.cFree3,'') as cFree3,
isnull(b.cFree4,'') as cFree4,
isnull(b.cFree5,'') as cFree5,
isnull(b.cFree6,'') as cFree6,
isnull(b.cFree7,'') as cFree7,
isnull(b.cFree8,'') as cFree8,
isnull(b.cFree9,'') as cFree9,
isnull(b.cFree10,'') as cFree10
                           from rdrecord01 a
                           left join rdrecords01 b on a.ID=b.ID
                           left join Department c on a.cDepCode=c.cDepCode
                           left join Vendor d on a.cVenCode=d.cVenCode
                          where a.cBusType='委外加工' AND A.ID in ({0}) ";
                         sql = string.Format(sql, iFatherIdTwo.TrimEnd(','));
                         if (ds != null)
                             ds.Merge(DBHelper.SQlReturnDataSet(sql, cmd));
                         else
                             ds = DBHelper.SQlReturnDataSet(sql, cmd);

                         #endregion

                     }
                     cmd.Transaction.Commit();
                 }
                 catch (Exception ex)
                 {
                     cmd.Transaction.Rollback();
                     log.Error(ex.Message);
                     throw new Exception(ex.Message);
                 }
                 finally
                 {
                     if (conn.State == ConnectionState.Open)
                     {
                         conn.Close();
                     }
                     conn.Dispose();
                 }
             }
            msg = JSON.DataSetToJson(ds, "details", "IDs");
            return msg;
        }
        /// <summary>
        /// 创建委外采购入(委外订单)
        /// </summary>
        /// <param name="Bills"></param>
        /// <returns></returns>
        //        public string CreateOutsourcingReceiveDocByPO(List<ICSOutsourcingReceiveDoc> Bills)
        //        {
        //            string msg = "";
        //            int num = 0;
        //            //取得out库单的默认显示模版
        //            Dictionary<string, int> dic = DBHelper.GetAllCode("" + ERPDB + "", "PuArrival", "" + num + "");
        //            int iFatherId = Convert.ToInt32(dic["iFatherId"].ToString());
        //            int iChildId = Convert.ToInt32(dic["iChildId"].ToString());
        //            DateTime date = DateTime.Now;
        //            string iBaseCodeLen = DBHelper.GetAllRDCode("26", "" + date + "", "admin");
        //            //取得采购入库单单据 表头ID，表体DID
        //            VouchKey key = new VouchKey();
        //            foreach (ICSOutsourcingReceiveDoc head in Bills)
        //            {
        //                num = head.ICSoutReceDoc.Count();
        //            }
        //            SqlConnection conn = new System.Data.SqlClient.SqlConnection(connString);
        //            conn.Open();
        //            SqlTransaction sqlTran = conn.BeginTransaction();
        //            SqlCommand cmd = new SqlCommand();
        //            cmd.Transaction = sqlTran;
        //            cmd.Connection = conn;
        //            try
        //            {
        //                if (Bills.Count <= 0)
        //                {
        //                    throw new Exception("传送数据为空！");
        //                }
        //                LogInfo(Bills);
        //                foreach (ICSOutsourcingReceiveDoc head in Bills)
        //                {
        //                    string sql = "";

        //                    #region 验证数量不能大于到货单数量

        //                    foreach (ICSOutsourcingReceiveDocs body in head.ICSoutReceDoc)
        //                    {
        //                        sql = "SELECT isnull(-iQuantity,0) FROM dbo.PU_ArrivalVouchs WHERE Autoid='" + body.ODNDetailID + "'";
        //                        DataTable dtQty = DBHelper.SQlReturnData(sql, cmd);
        //                        if (dtQty != null && dtQty.Rows.Count > 0)
        //                        {
        //                            //到货单可入数量
        //                            decimal PUQty = Convert.ToDecimal(dtQty.Rows[0][0]);
        //                            sql = "SELECT ISNULL(SUM(-iQuantity),0) FROM dbo.RdRecords01 WHERE iArrsId='" + body.ODNDetailID + "'";
        //                            DataTable dtReceQty = DBHelper.SQlReturnData(sql, cmd);
        //                            decimal ReceQty = Convert.ToDecimal(dtReceQty.Rows[0][0]);
        //                            if (ReceQty + body.Quantity > PUQty)
        //                            {
        //                                throw new Exception("入库数量大于当前到货单行可入库数量！");
        //                            }
        //                        }
        //                        else
        //                        {
        //                            throw new Exception("U8不存在该到货单行！");
        //                        }
        //                    }

        //                    #endregion

        //                    #region 委外采购入库单 表头

        //                    sql = @"INSERT INTO dbo.RdRecord01
        //                        ( ID ,bRdFlag ,cVouchType ,cBusType ,cSource ,cWhCode ,
        //                          dDate ,cCode ,cRdCode ,cDepCode ,cPersonCode ,cPTCode ,
        //                          cVenCode ,cOrderCode ,cARVCode ,cHandler ,cMemo ,
        //                          bTransFlag ,cMaker ,cDefine1 ,cDefine2 ,cDefine3 ,
        //                          cDefine4 ,cDefine5 ,cDefine6 ,cDefine7 ,cDefine8 ,
        //                          cDefine9 ,cDefine10 ,dVeriDate ,bpufirst ,biafirst ,
        //                		  dARVDate ,VT_ID ,bIsSTQc ,cDefine11 ,cDefine12 ,
        //                          cDefine13 ,cDefine14 ,cDefine15 ,cDefine16 ,
        //                          ipurarriveid ,iTaxRate ,iExchRate ,cExch_Name ,bOMFirst,
        //                          bFromPreYear ,bIsComplement ,iDiscountTaxType ,
        //                          ireturncount ,iverifystate ,iswfcontrolled ,
        //                          cModifyPerson ,dnmaketime ,dnverifytime ,
        //                          bredvouch  ,bCredit ,iPrintCount)
        //                SELECT @ID,1,'01','委外加工','委外到货单',@cWhCode,
        //                		CONVERT(NVARCHAR(15),GETDATE(),23),@cCode,'101',@cDepCode,a.cPersonCode,'01',
        //                		a.cVenCode,b.cCode,a.cCode,@cHandler,a.cMemo,
        //                		0,@cMaker,a.cDefine1,a.cDefine2,a.cDefine3,
        //                		a.cDefine4,a.cDefine5,a.cDefine6,a.cDefine7,a.cDefine8,
        //                		a.cDefine9,a.cDefine10,CONVERT(NVARCHAR(15),GETDATE(),23),0,0,
        //                		a.dDate,@VT_ID,0,a.cDefine11,a.cDefine12,
        //                		a.cDefine13,a.cDefine14,a.cDefine15,a.cDefine16,
        //                		a.ID,a.iTaxRate,a.iExchRate,a.cexch_name,0,
        //                		0,0,0,
        //                		0,0,0,
        //                		'',GETDATE(),GETDATE(),
        //                		0,0,0
        //                 FROM dbo.PU_ArrivalVouch a LEFT JOIN dbo.OM_MOMain b ON a.cpocode=b.cCode WHERE b.cCode='" + head.ODNCode + "'";
        //                    cmd.Parameters.Clear();
        //                    cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
        //                    cmd.Parameters.Add(new SqlParameter("@cWhCode", head.WHCode));
        //                    cmd.Parameters.Add(new SqlParameter("@cCode", iBaseCodeLen));
        //                    cmd.Parameters.Add(new SqlParameter("@cDepCode", ""));
        //                    cmd.Parameters.Add(new SqlParameter("@cHandler", head.User));
        //                    cmd.Parameters.Add(new SqlParameter("@cMaker", head.User));
        //                    cmd.Parameters.Add(new SqlParameter("@VT_ID", iChildId));
        //                    cmd.CommandText = sql;
        //                    try
        //                    {
        //                        int count = cmd.ExecuteNonQuery();
        //                        if (count <= 0)
        //                        {
        //                            log.Error("委外采购入库单表头失败，受影响行数<=0；");
        //                            throw new Exception("委外采购入库单表头失败，受影响行数<=0；");
        //                        }
        //                    }
        //                    catch (Exception ex)
        //                    {
        //                        log.Error("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
        //                        throw new Exception("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
        //                    }


        //                    #endregion

        //                    #region 采购入库单 表体
        //                    int irowno = 0;
        //                    foreach (ICSOutsourcingReceiveDocs body in head.ICSoutReceDoc)
        //                    {
        //                        sql = @"INSERT INTO dbo.rdrecords01
        //          ( AutoID ,ID ,cInvCode ,iQuantity ,iUnitCost ,iPrice ,iAPrice ,
        //            iFlag ,iSQuantity ,iSNum ,iMoney ,
        //            cDefine22 ,cDefine23 ,cDefine24 ,cDefine25 ,cDefine26 ,cDefine27 ,
        //            cItem_class ,cItemCode ,iPOsID ,fACost ,cName  ,iNQuantity ,
        //            chVencode ,iArrsId ,iOriTaxCost ,iOriCost ,iOriMoney ,iOriTaxPrice ,
        //            ioriSum ,iTaxRate ,iTaxPrice ,iSum ,bTaxCost ,cPOID ,iMatSettleState ,
        //            iBillSettleCount ,bLPUseFree ,iOriTrackID ,bCosting ,cbarvcode ,
        //            dbarvdate ,iExpiratDateCalcu ,iordertype ,isotype ,irowno ,bgift,cBatch,iProcessFee, iProcessCost )
        //  SELECT @AutoID,@ID,@cInvCode,@iQuantity,0,0,0,
        //  		0,0,0,0,
        //  		a.cDefine22,a.cDefine23,a.cDefine24,a.cDefine25,a.cDefine26,a.cDefine27,
        //  		a.cItem_class,a.cItemCode,a.iPOsID,0,a.cItemName,a.iQuantity,
        //  		c.cVenCode,a.Autoid,0,0,0,0,
        //  		0,a.iTaxRate,0,0,1,d.cCode,0,
        //  		0,0,0,1,c.cCode,
        //  		c.dDate,0,0,0,@irowno,0,@cBatch,a.iCost*convert(decimal, @iQuantity),a.iCost
        //  FROM dbo.PU_ArrivalVouchs a LEFT JOIN dbo.OM_MODetails b ON a.iPOsID=b.MODetailsID
        //  INNER JOIN dbo.OM_MOMain d ON b.MOID=d.MOID
        //  INNER JOIN dbo.PU_ArrivalVouch c ON a.ID=c.ID where b.Autoid='" + body.ODNDetailID + "'";
        //                        cmd.Parameters.Clear();
        //                        cmd.Parameters.Add(new SqlParameter("@AutoID", iChildId));
        //                        cmd.Parameters.Add(new SqlParameter("@ID", iFatherId));
        //                        cmd.Parameters.Add(new SqlParameter("@cInvCode", body.InvCode));
        //                        cmd.Parameters.Add(new SqlParameter("@iQuantity", body.Quantity));
        //                        cmd.Parameters.Add(new SqlParameter("@irowno", irowno));
        //                        cmd.Parameters.Add(new SqlParameter("@cBatch", ""));
        //                        cmd.CommandText = sql;
        //                        try
        //                        {
        //                            int count = cmd.ExecuteNonQuery();
        //                            if (count <= 0)
        //                            {
        //                                log.Error("委外采购入库单表头失败，受影响行数<=0；");
        //                                throw new Exception("委外采购入库单表头失败，受影响行数<=0；");
        //                            }
        //                        }
        //                        catch (Exception ex)
        //                        {
        //                            log.Error("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
        //                            throw new Exception("委外采购入库单表头失败！SQL：\r\n" + sql, ex);
        //                        }


        //                        //更新现存量
        //                        key.cBustypeUN = "委外加工";
        //                        key.cVouchTypeUN = "01";
        //                        key.TableName = "IA_ST_UnAccountVouch01";
        //                        DBHelper.UpdateCurrentStock(cmd, body.InvCode, head.WHCode, "", body.Quantity, key);

        //                        //OM_MODetails
        //                        sql = @"UPDATE b SET freceivedqty=ISNULL(freceivedqty,0)+" + body.Quantity + @" 
        //                                FROM dbo.PU_ArrivalVouchs a LEFT JOIN dbo.OM_MODetails b ON a.iPOsID=b.MODetailsID
        //                                WHERE a.Autoid='" + body.ODNDetailID + "'";
        //                        DBHelper.CmdExecuteNonQuery(sql, cmd, "回写OM_MODetails失败！");
        //                        //回写PU_ArrivalVouchs失败
        //                        sql = "UPDATE dbo.PU_ArrivalVouchs SET fValidInQuan=ISNULL(fValidInQuan,0)+" + body.Quantity + " WHERE Autoid='" + body.ODNDetailID + "'";
        //                        DBHelper.CmdExecuteNonQuery(sql, cmd, "回写PU_ArrivalVouchs失败！");

        //                        //更新待入库数量
        //                        sql = "UPDATE dbo.CurrentStock SET fInQuantity=ISNULL(fInQuantity,0)-" + body.Quantity + " WHERE cInvCode='" + body.InvCode + "' AND cWhCode ='" + head.WHCode + "'";
        //                        if (DBHelper.bInvBatch(body.InvCode, cmd) == true)
        //                        {
        //                            //if (!string.IsNullOrWhiteSpace(body.cBatch))
        //                            //{
        //                            //    sql += " and cBatch='" + body.cBatch + "'";
        //                            //}
        //                        }
        //                        DBHelper.CmdExecuteNonQuery(sql, cmd, "更新待入库数量失败！");
        //                        #region 判断现存量是否足够
        //                        sql = @"IF EXISTS(SELECT AutoID FROM dbo.CurrentStock WHERE iQuantity<0 OR iNum<0 OR fInQuantity<0)
        //                        BEGIN
        //	                        DECLARE @MSG NVARCHAR(100)
        //	                        SELECT @MSG='ERP待入库数量不足！AutoID：'+CAST(AutoID AS NVARCHAR(100)) FROM dbo.CurrentStock WHERE iQuantity<0 OR iNum<0 OR fInQuantity<0
        // 	                        RAISERROR(@MSG,16,1)
        //                        END";

        //                        cmd.CommandText = sql;
        //                        cmd.ExecuteNonQuery();
        //                        #endregion
        //                    }

        //                    #endregion

        //                }
        //                GetSerialCode(iFatherId.ToString());
        //                cmd.Transaction.Commit();
        //                return msg;
        //            }
        //            catch (Exception ex)
        //            {
        //                cmd.Transaction.Rollback();
        //                log.Error(ex.Message);
        //                throw new Exception(ex.Message);
        //            }
        //            finally
        //            {
        //                if (conn.State == ConnectionState.Open)
        //                {
        //                    conn.Close();
        //                }
        //                conn.Dispose();
        //            }
        //        }
        /// <summary>
        /// 审核委外采购入库
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public string Approve(List<ICSOutsourcingReceiveDocNegative> infos)
        {
            List<ICSSalesShipmentDoc> szJson = new List<ICSSalesShipmentDoc>();
            string json = "";
            string connS = "";
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            string sql = string.Empty;
               List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


               foreach (string WorkPoint in result)
               {
                   try
                   {
                       connS = string.Format(connString, WorkPoint);
                       conn = new System.Data.SqlClient.SqlConnection(connS);
                       conn.Open();
                       SqlTransaction sqlTran = conn.BeginTransaction();
                       cmd = new SqlCommand();
                       cmd.Transaction = sqlTran;
                       cmd.Connection = conn;
                       foreach (ICSOutsourcingReceiveDocNegative info in infos)
                       {
                           if (WorkPoint != info.WorkPoint)
                               continue;

                           ICSUserInfo userInfo = new ICSUserInfo();
                           userInfo = DBHelper.GetPersonInfo(info.User, cmd);
                           if (info.MTime < new DateTime(2000, 01, 01))
                               throw new Exception("请输入正确的操作时间：" + info.MTime);
                           sql = @"UPDATE  RdRecord01 SET cHandler ='" + userInfo.UserName + @"' ,
                            dnverifytime=CONVERT(VARCHAR(50),GETDATE(),112),dVeriDate=GETDATE() WHERE ID='{0}'";
                           sql = string.Format(sql, info.ID);
                           DBHelper.CmdExecuteNonQuery(sql, cmd, "审核委外采购入库单失败！");

                       }
                       cmd.Transaction.Commit();
                   }
                   catch (Exception ex)
                   {
                       cmd.Transaction.Rollback();
                       log.Error(ex.Message);
                       throw new Exception(ex.Message);
                   }
                   finally
                   {
                       if (conn.State == ConnectionState.Open)
                       {
                           conn.Close();
                       }
                       conn.Dispose();
                   }
               }
            return json;

        }
        /// <summary>
        /// 删除委外采购入库单
        /// </summary>
        /// <param name="infos"></param>
        /// <returns></returns>
        public string Delete(List<ICSOutsourcingReceiveDocNegative> infos)
        {
            List<ICSSalesShipmentDoc> szJson = new List<ICSSalesShipmentDoc>();
            if (infos.Count <= 0)
            {
                throw new Exception("传送数据为空！");
            }
            string connS = "";
            string res = string.Empty;
            SqlConnection conn = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            string sql = string.Empty;

             List<string> result = infos.Select(t => t.WorkPoint).Distinct().ToList();


             foreach (string WorkPoint in result)
             {
                 try
                 {
                     connS = string.Format(connString, WorkPoint);
                     conn = new System.Data.SqlClient.SqlConnection(connS);
                     conn.Open();
                     SqlTransaction sqlTran = conn.BeginTransaction();
                     cmd = new SqlCommand();
                     cmd.Transaction = sqlTran;
                     cmd.Connection = conn;
                     foreach (ICSOutsourcingReceiveDocNegative info in infos)
                     {
                         if (WorkPoint != info.WorkPoint)
                             continue;
                         if (info.MTime < new DateTime(2000, 01, 01))
                             throw new Exception("请输入正确的操作时间：" + info.MTime);
                         sql = @"delete  RdRecord01  where  RdRecord01.ID='" + info.ID + "'";
                         sql += @"delete  RdRecords01  where  RdRecords01.ID='" + info.ID + "'";
                         //UPDATE dbo.rdrecord11 a SET cHandler='" + info.User + @"' ,
                         //                            dVeriDate=CONVERT(VARCHAR(50),GETDATE(),112),dnverifytime=GETDATE() 
                         //                            WHERE a.ID='" + info.ID + "'";
                         DBHelper.CmdExecuteNonQuery(sql, cmd, "删除委外采购入库单失败！");

                     }
                     cmd.Transaction.Commit();
                 }
                 catch (Exception ex)
                 {
                     cmd.Transaction.Rollback();
                     log.Error(ex.Message);
                     throw new Exception(ex.Message);
                 }
                 finally
                 {
                     if (conn.State == ConnectionState.Open)
                     {
                         conn.Close();
                     }
                     conn.Dispose();
                 }
             }
            return res;
        }
        /// <summary>
        /// 
        /// 记录日志
        /// </summary>
        /// <param name="Bills"></param>
        private void LogInfo(List<ICSOutsourcingReceiveDocNegative> Bills)
        {
            string HeadList = string.Empty;
            string BodyList = string.Empty;
            foreach (ICSOutsourcingReceiveDocNegative head in Bills)
            {
                HeadList += "\r\n 表头主键ID：" + head.ID + "，仓库：" + head.WHCode + "，用户：" + head.User + "，站点：" + head.WorkPoint;
                foreach (ICSOutsourcingReceiveDocNegatives body in head.details)
                {
                    BodyList += "\r\n 表体主键ID： " + body.ODNRTDetailID + "，数量：" + body.Quantity;
                }
            }
            log.Info(HeadList);
            log.Info(BodyList);
        }
        public string GetSerialCode(string ID, string connS)
        {
            string sql = "EXEC Addins_GetSerialCode '{0}'";
            sql = string.Format(sql, new object[] { ID });
            return DBHelper.ExecuteScalar(CommandType.Text, sql, connS).ToString();
        }
    }
}
